Approve agent
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "approveAgent",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"agentAddress": "0x1234567890abcdef1234567890abcdef12345678",
"agentName": null,
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "approveAgent",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"agentAddress": "0x1234567890abcdef1234567890abcdef12345678",
"agentName": None,
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'approveAgent',
hyperliquidChain: 'Mainnet',
signatureChainId: '0xa4b1',
agentAddress: '0x1234567890abcdef1234567890abcdef12345678',
agentName: null,
nonce: 1705234567890
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
approveAgent | Hyperliquid exchange
Approves an agent address to trade on behalf of the user. Agents can place and cancel orders but cannot withdraw funds. On Hyperliquid exchange.
POST
/
exchange
Approve agent
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"approveAgent"hyperliquidChain(string) — Chain identifieragentAddress(string) — Agent wallet address to approveagentName(string) — Human-readable agent name (optional)nonce(integer) — Unique nonce for the approval
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "approveAgent"},
"nonce": 1234567890123,
"signature": {...}
}'
import eth_account
from eth_account.signers.local import LocalAccount
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
# Your master account wallet (this signs the approval).
wallet: LocalAccount = eth_account.Account.from_key("0x_your_private_key")
# Public Hyperliquid mainnet API.
exchange = Exchange(wallet, constants.MAINNET_API_URL)
# approve_agent generates a fresh agent key internally and returns the API
# response together with the agent's private key. Pass an optional name to
# create a named (persistent) agent.
approve_result, agent_key = exchange.approve_agent("myAgent")
print(approve_result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Your master account wallet (this signs the approval).
const wallet = privateKeyToAccount("0x_your_private_key");
// Public Hyperliquid mainnet API.
const transport = new HttpTransport();
const client = new ExchangeClient({ transport, wallet });
const result = await client.approveAgent({
agentAddress: "0x_agent_address",
agentName: "myAgent",
});
console.log(result);
Use case
- Approve agent — Approves an agent address to trade on behalf of the user. Agents can place and cancel orders but cannot withdraw funds.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?